/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.jtests.clients.entity;

import java.util.Date;

import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

import junit.framework.Test;
import junit.framework.TestSuite;

import org.objectweb.jonas.jtests.beans.etype.outildate.OutildateHome;

/**
 * This is a test suite about java.util.Date field of entity bean CMP version 2.
 * Beans used: etype/outildate
 * @author Helene Joanin
 */

public class F_EtypeOutildateEC2 extends A_EtypeOutildate {

    private static String BEAN_HOME = "EtypeOutildateEC2Home";
    protected static OutildateHome home = null;
    private static final long ONE_HOUR = 60L*60L*1000L;
    private static final long ONE_DAY = 24L*ONE_HOUR;

    public F_EtypeOutildateEC2(String name) {
        super(name);
    }

    protected void setUp() {
        super.setUp();
        useBeans("outildate", false);
    }

    public OutildateHome getHome() {
        if (home == null) {
            try {
                home = (OutildateHome) PortableRemoteObject.narrow(ictx.lookup(BEAN_HOME),
                        OutildateHome.class);
            } catch (NamingException e) {
                fail("Cannot get bean home: "+BEAN_HOME);
            }
            // init here tables if CMP2
            try {
                home.create("pk1", new Date(ONE_DAY));
                home.create("pk2", new Date(2*ONE_DAY));
                home.create("pk3", new Date(3*ONE_DAY));
                home.create("pk4", new Date(4*ONE_DAY));
                home.create("pk5", new Date(5*ONE_DAY));
                home.create("pk5bis", new Date(5*ONE_DAY));
                home.create("pktoremove", new Date(12*ONE_DAY));
                home.create("pknull", (Date) null);
                home.create("pkchangenull", new Date(12*ONE_DAY));
            } catch (Exception i) {
            }
        }
        return home;
    }

    public static Test suite() {
        return new TestSuite(F_EtypeOutildateEC2.class);
    }

    public static void main (String args[]) {
        String testtorun = null;
        // Get args
        for (int argn = 0; argn < args.length; argn++) {
            String s_arg = args[argn];
            Integer i_arg;
            if (s_arg.equals("-n")) {
                testtorun = args[++argn];
            } 
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new F_EtypeOutildateEC2(testtorun));
        }
    }
}
